#!/usr/bin/env sh
export XML_CATALOG_FILES=/sw/etc/xml/catalog
export SGML_CATALOG_FILES=/sw/etc/sgml/catalog
INSTALLDIR=/Volumes/iDisk/Sites/tutorial
DTD=/sw/share/sgml/dsssl/docbook-dsssl-nwalsh/dtds/decls/xml.dcl
DIR=$PWD
DOC=`which docbook2html`
if !(test -r $XML_CATALOG_FILES && test -r $SGML_CATALOG_FILES && test -r $DTD); then 
    echo "ERROR Missing Catalog file(s) or DTD";
    exit
fi

if !(test -x $INSTALLDIR); then
    echo ERROR $INSTALLDIR must be a directory;
    exit
fi

if !(test -x $INSTALLDIR/html); then
    mkdir $INSTALLDIR/html;
fi

if !(test -x $INSTALLDIR/images); then
    cp -R images $INSTALLDIR/images;
fi

if !(test -x $DOC); then
    echo ERROR docbook2html $DOC must be a executable.;
    exit
elif !(test -r $DIR/tutorial.dbk); then 
    echo ERROR no docbook file $DIR/tutorial.dbk;
    exit
else 
    cd $INSTALLDIR/html;
    rm *.html;
    $DOC -l $DTD $DIR/tutorial.dbk;
    cd $DIR;
fi
