############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

import ZSI
from pyGridWare.patterns import Singleton
from pyGridWare.resource.ResourceHomeManager import ResourceHomeManager
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceContext import ResourceContext
from pyGridWare.resource.ResourceHome import SimpleResourceHome
from pyGridWare.resource.ResourceContext import ScheduledResourceTerminationContext as _ScheduledResourceTerminationContext
from pyGridWare.generated.properties.managedjobservice.ManagedJobService.ManagedJobPortTypePort import ManagedJobPortType


class Key(int):
    typecode = ZSI.TC.Iint(pname=('http://www.globus.org/namespaces/2004/10/gram/job/service','ManagedJobKey'))


class ManagerHome(ResourceHomeManager, Singleton):
    def getResourceContext(self, ps, address):
        key = AddressingUtils.getResourceID(ps, Key.typecode)
        return self.get(key)


class ManagedJobPortTypeContext(_ScheduledResourceTerminationContext, ResourceContext):
    def __init__(self, properties_class=ManagedJobPortType):
        ResourceContext.__init__(self, properties_class)
        _ScheduledResourceTerminationContext.__init__(self, properties_class)

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, Key(resourceID))
ManagedJobPortTypeContext.home = ManagerHome.getInstance(SimpleResourceHome())

