################################################## 
# WS_BaseNotification_services.py 
# generated by ZSI.generate.wsdl2python
##################################################


from pyGridWare.generated.types.basenotification import *
import urlparse, types
import ZSI
from ZSI.TC import _get_global_element_declaration as GED
from ZSI.TCcompound import Struct
from pyGridWare.utility import client
from pyGridWare.utility.dom import DomletteReader, DomletteElementProxy
from twisted.python.failure import Failure

# Locator
class WS_BaseNotificationServiceLocator:
    NotificationConsumer_address = "http://localhost:8080/wsrf/services/"
    def getNotificationConsumerAddress(self):
        return WS_BaseNotificationServiceLocator.NotificationConsumer_address
    def getNotificationConsumer(self, url=None, **kw):
        return NotificationConsumerSOAPBindingSOAP(url or WS_BaseNotificationServiceLocator.NotificationConsumer_address, **kw)
    NotificationProducer_address = "http://localhost:8080/wsrf/services/"
    def getNotificationProducerAddress(self):
        return WS_BaseNotificationServiceLocator.NotificationProducer_address
    def getNotificationProducer(self, url=None, **kw):
        return NotificationProducerSOAPBindingSOAP(url or WS_BaseNotificationServiceLocator.NotificationProducer_address, **kw)
    SubscriptionManager_address = "http://localhost:8080/wsrf/services/"
    def getSubscriptionManagerAddress(self):
        return WS_BaseNotificationServiceLocator.SubscriptionManager_address
    def getSubscriptionManager(self, url=None, **kw):
        return SubscriptionManagerSOAPBindingSOAP(url or WS_BaseNotificationServiceLocator.SubscriptionManager_address, **kw)

# Methods
class NotificationConsumerSOAPBindingSOAP:
    defer = False
    def __init__(self, url, endPointReference=None, **kw):
        kw.setdefault("readerclass", DomletteReader)
        kw.setdefault("writerclass", DomletteElementProxy)
        # no resource properties
        self.binding = client.Binding(url=url, **kw)
        self.endPointReference = endPointReference

    # op: Notify
    def Notify(self, request):
        if isinstance(request, Notify) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Notify"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Notify", wsaction=wsaction, endPointReference=self.endPointReference, **kw)

# Methods
class NotificationProducerSOAPBindingSOAP:
    defer = False
    def __init__(self, url, endPointReference=None, **kw):
        kw.setdefault("readerclass", DomletteReader)
        kw.setdefault("writerclass", DomletteElementProxy)
        kw.setdefault("ResourceProperties", ("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","NotificationProducerRP"))
        self.binding = client.Binding(url=url, **kw)
        self.endPointReference = endPointReference

    # op: GetResourceProperty
    def GetResourceProperty(self, request):
        if isinstance(request, GetResourcePropertyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetResourcePropertyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetResourcePropertyResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetResourcePropertyResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: Subscribe
    def Subscribe(self, request):
        if isinstance(request, SubscribeRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/SubscribeResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=SubscribeResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(SubscribeResponse.typecode, wsaction=wsaction)
        if isinstance(response, SubscribeResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: GetCurrentMessage
    def GetCurrentMessage(self, request):
        if isinstance(request, GetCurrentMessageRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessageResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetCurrentMessageResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetCurrentMessageResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetCurrentMessageResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

# Methods
class SubscriptionManagerSOAPBindingSOAP:
    defer = False
    def __init__(self, url, endPointReference=None, **kw):
        kw.setdefault("readerclass", DomletteReader)
        kw.setdefault("writerclass", DomletteElementProxy)
        kw.setdefault("ResourceProperties", ("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","SubscriptionManagerRP"))
        self.binding = client.Binding(url=url, **kw)
        self.endPointReference = endPointReference

    # op: GetResourceProperty
    def GetResourceProperty(self, request):
        if isinstance(request, GetResourcePropertyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetResourcePropertyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetResourcePropertyResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetResourcePropertyResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: Destroy
    def Destroy(self, request):
        if isinstance(request, DestroyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/DestroyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=DestroyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(DestroyResponse.typecode, wsaction=wsaction)
        if isinstance(response, DestroyResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: SetTerminationTime
    def SetTerminationTime(self, request):
        if isinstance(request, SetTerminationTimeRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTime"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTime", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTimeResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=SetTerminationTimeResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(SetTerminationTimeResponse.typecode, wsaction=wsaction)
        if isinstance(response, SetTerminationTimeResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: PauseSubscription
    def PauseSubscription(self, request):
        if isinstance(request, PauseSubscriptionRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/PauseSubscription"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/PauseSubscription", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/PauseSubscriptionResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=PauseSubscriptionResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(PauseSubscriptionResponse.typecode, wsaction=wsaction)
        if isinstance(response, PauseSubscriptionResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: ResumeSubscription
    def ResumeSubscription(self, request):
        if isinstance(request, ResumeSubscriptionRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/ResumeSubscription"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/ResumeSubscription", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/ResumeSubscriptionResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=ResumeSubscriptionResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(ResumeSubscriptionResponse.typecode, wsaction=wsaction)
        if isinstance(response, ResumeSubscriptionResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response
Notify = ns3.Notify_Dec().pyclass

class GetResourcePropertyRequest(tuple):
    typecode = ns2.GetResourceProperty_Dec()

GetResourcePropertyResponse = ns2.GetResourcePropertyResponse_Dec().pyclass

SubscribeRequest = ns3.Subscribe_Dec().pyclass

SubscribeResponse = ns3.SubscribeResponse_Dec().pyclass

GetCurrentMessageRequest = ns3.GetCurrentMessage_Dec().pyclass

GetCurrentMessageResponse = ns3.GetCurrentMessageResponse_Dec().pyclass

class GetResourcePropertyRequest(tuple):
    typecode = ns2.GetResourceProperty_Dec()

GetResourcePropertyResponse = ns2.GetResourcePropertyResponse_Dec().pyclass

DestroyRequest = ns1.Destroy_Dec().pyclass

DestroyResponse = ns1.DestroyResponse_Dec().pyclass

SetTerminationTimeRequest = ns1.SetTerminationTime_Dec().pyclass

SetTerminationTimeResponse = ns1.SetTerminationTimeResponse_Dec().pyclass

PauseSubscriptionRequest = ns3.PauseSubscription_Dec().pyclass

PauseSubscriptionResponse = ns3.PauseSubscriptionResponse_Dec().pyclass

ResumeSubscriptionRequest = ns3.ResumeSubscription_Dec().pyclass

ResumeSubscriptionResponse = ns3.ResumeSubscriptionResponse_Dec().pyclass

