################################################## 
# DelegationFactoryService_services.py 
# generated by ZSI.generate.wsdl2python
##################################################


from pyGridWare.generated.types.delegationservice import *
import urlparse, types
import ZSI
from ZSI.TC import _get_global_element_declaration as GED
from ZSI.TCcompound import Struct
from pyGridWare.utility import client
from pyGridWare.utility.dom import DomletteReader, DomletteElementProxy
from twisted.python.failure import Failure

# Locator
class DelegationFactoryServiceLocator:
    DelegationFactoryPortType_address = "http://localhost:8080/wsrf/services/"
    def getDelegationFactoryPortTypeAddress(self):
        return DelegationFactoryServiceLocator.DelegationFactoryPortType_address
    def getDelegationFactoryPortType(self, url=None, **kw):
        return DelegationFactoryPortTypeSOAPBindingSOAP(url or DelegationFactoryServiceLocator.DelegationFactoryPortType_address, **kw)

# Methods
class DelegationFactoryPortTypeSOAPBindingSOAP:
    defer = False
    def __init__(self, url, endPointReference=None, **kw):
        kw.setdefault("readerclass", DomletteReader)
        kw.setdefault("writerclass", DomletteElementProxy)
        kw.setdefault("ResourceProperties", ("http://www.globus.org/08/2004/delegationService","RPSet"))
        self.binding = client.Binding(url=url, **kw)
        self.endPointReference = endPointReference

    # op: RequestSecurityToken
    def RequestSecurityToken(self, request):
        if isinstance(request, RequestSecurityTokenMsg) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://www.globus.org/08/2004/delegationService/DelegationFactoryPortType/RequestSecurityTokenRequest"
        d = self.binding.Send(None, None, request, soapaction="http://www.globus.org/08/2004/delegationService/DelegationFactoryPortType/RequestSecurityTokenRequest", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://www.globus.org/08/2004/delegationService/DelegationFactoryPortType/RequestSecurityTokenResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=RequestSecurityTokenResponseMsg.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(RequestSecurityTokenResponseMsg.typecode, wsaction=wsaction)
        if isinstance(response, RequestSecurityTokenResponseMsg.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: RequestSecurityToken2
    def RequestSecurityToken2(self, request):
        if isinstance(request, RequestSecurityTokenMsg) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://www.globus.org/08/2004/delegationService/DelegationFactoryPortType/RequestSecurityToken2Request"
        d = self.binding.Send(None, None, request, soapaction="http://www.globus.org/08/2004/delegationService/DelegationFactoryPortType/RequestSecurityToken2Request", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://www.globus.org/08/2004/delegationService/DelegationFactoryPortType/RequestSecurityToken2Response"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=RequestSecurityTokenResponseCollectionMsg.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(RequestSecurityTokenResponseCollectionMsg.typecode, wsaction=wsaction)
        if isinstance(response, RequestSecurityTokenResponseCollectionMsg.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: QueryResourceProperties
    def QueryResourceProperties(self, request):
        if isinstance(request, QueryResourcePropertiesRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourceProperties"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourceProperties", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourcePropertiesResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=QueryResourcePropertiesResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(QueryResourcePropertiesResponse.typecode, wsaction=wsaction)
        if isinstance(response, QueryResourcePropertiesResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: GetResourceProperty
    def GetResourceProperty(self, request):
        if isinstance(request, GetResourcePropertyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetResourcePropertyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetResourcePropertyResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetResourcePropertyResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response
RequestSecurityTokenMsg = ns21.RequestSecurityToken_Dec().pyclass

RequestSecurityTokenResponseMsg = ns21.RequestSecurityTokenResponse_Dec().pyclass

RequestSecurityTokenMsg = ns21.RequestSecurityToken_Dec().pyclass

RequestSecurityTokenResponseCollectionMsg = ns21.RequestSecurityTokenResponseCollection_Dec().pyclass

QueryResourcePropertiesRequest = ns2.QueryResourceProperties_Dec().pyclass

QueryResourcePropertiesResponse = ns2.QueryResourcePropertiesResponse_Dec().pyclass

class GetResourcePropertyRequest(tuple):
    typecode = ns2.GetResourceProperty_Dec()

GetResourcePropertyResponse = ns2.GetResourcePropertyResponse_Dec().pyclass

