################################################## 
# ManagedJob_services.py 
# generated by ZSI.generate.wsdl2python
##################################################


from pyGridWare.generated.types.managedjobservice import *
import urlparse, types
import ZSI
from ZSI.TC import _get_global_element_declaration as GED
from ZSI.TCcompound import Struct
from pyGridWare.utility import client
from pyGridWare.utility.dom import DomletteReader, DomletteElementProxy
from twisted.python.failure import Failure

# Locator
class ManagedJobServiceLocator:
    ManagedJobPortType_address = "http://localhost:8080/wsrf/services/"
    def getManagedJobPortTypeAddress(self):
        return ManagedJobServiceLocator.ManagedJobPortType_address
    def getManagedJobPortType(self, url=None, **kw):
        return ManagedJobPortTypeSOAPBindingSOAP(url or ManagedJobServiceLocator.ManagedJobPortType_address, **kw)

# Methods
class ManagedJobPortTypeSOAPBindingSOAP:
    defer = False
    def __init__(self, url, endPointReference=None, **kw):
        kw.setdefault("readerclass", DomletteReader)
        kw.setdefault("writerclass", DomletteElementProxy)
        kw.setdefault("ResourceProperties", ("http://www.globus.org/namespaces/2004/10/gram/job","managedJobResourceProperties"))
        self.binding = client.Binding(url=url, **kw)
        self.endPointReference = endPointReference

    # op: release
    def release(self, request):
        if isinstance(request, releaseInputMessage) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://www.globus.org/namespaces/2004/10/gram/job/release"
        d = self.binding.Send(None, None, request, soapaction="http://www.globus.org/namespaces/2004/10/gram/job/release", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://www.globus.org/namespaces/2004/10/gram/job/releaseResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=releaseOutputMessage.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(releaseOutputMessage.typecode, wsaction=wsaction)
        if isinstance(response, releaseOutputMessage.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: register
    def register(self, request):
        if isinstance(request, RegisterInputMessage) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobPortType/registerRequest"
        d = self.binding.Send(None, None, request, soapaction="http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobPortType/registerRequest", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobPortType/registerResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=RegisterOutputMessage.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(RegisterOutputMessage.typecode, wsaction=wsaction)
        if isinstance(response, RegisterOutputMessage.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: GetResourceProperty
    def GetResourceProperty(self, request):
        if isinstance(request, GetResourcePropertyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetResourcePropertyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetResourcePropertyResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetResourcePropertyResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: Subscribe
    def Subscribe(self, request):
        if isinstance(request, SubscribeRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/SubscribeResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=SubscribeResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(SubscribeResponse.typecode, wsaction=wsaction)
        if isinstance(response, SubscribeResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: GetCurrentMessage
    def GetCurrentMessage(self, request):
        if isinstance(request, GetCurrentMessageRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessageResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetCurrentMessageResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetCurrentMessageResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetCurrentMessageResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: SetTerminationTime
    def SetTerminationTime(self, request):
        if isinstance(request, SetTerminationTimeRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTime"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTime", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTimeResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=SetTerminationTimeResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(SetTerminationTimeResponse.typecode, wsaction=wsaction)
        if isinstance(response, SetTerminationTimeResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: Destroy
    def Destroy(self, request):
        if isinstance(request, DestroyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/DestroyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=DestroyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(DestroyResponse.typecode, wsaction=wsaction)
        if isinstance(response, DestroyResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: QueryResourceProperties
    def QueryResourceProperties(self, request):
        if isinstance(request, QueryResourcePropertiesRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourceProperties"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourceProperties", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourcePropertiesResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=QueryResourcePropertiesResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(QueryResourcePropertiesResponse.typecode, wsaction=wsaction)
        if isinstance(response, QueryResourcePropertiesResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: GetMultipleResourceProperties
    def GetMultipleResourceProperties(self, request):
        if isinstance(request, GetMultipleResourcePropertiesRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourceProperties"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourceProperties", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourcePropertiesResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetMultipleResourcePropertiesResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetMultipleResourcePropertiesResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetMultipleResourcePropertiesResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response
releaseInputMessage = ns7.release_Dec().pyclass

releaseOutputMessage = ns7.releaseResponse_Dec().pyclass

RegisterInputMessage = ns8.registerInput_Dec().pyclass

RegisterOutputMessage = ns8.registerResponse_Dec().pyclass

class GetResourcePropertyRequest(tuple):
    typecode = ns2.GetResourceProperty_Dec()

GetResourcePropertyResponse = ns2.GetResourcePropertyResponse_Dec().pyclass

SubscribeRequest = ns3.Subscribe_Dec().pyclass

SubscribeResponse = ns3.SubscribeResponse_Dec().pyclass

GetCurrentMessageRequest = ns3.GetCurrentMessage_Dec().pyclass

GetCurrentMessageResponse = ns3.GetCurrentMessageResponse_Dec().pyclass

SetTerminationTimeRequest = ns1.SetTerminationTime_Dec().pyclass

SetTerminationTimeResponse = ns1.SetTerminationTimeResponse_Dec().pyclass

DestroyRequest = ns1.Destroy_Dec().pyclass

DestroyResponse = ns1.DestroyResponse_Dec().pyclass

QueryResourcePropertiesRequest = ns2.QueryResourceProperties_Dec().pyclass

QueryResourcePropertiesResponse = ns2.QueryResourcePropertiesResponse_Dec().pyclass

GetMultipleResourcePropertiesRequest = ns2.GetMultipleResourceProperties_Dec().pyclass

GetMultipleResourcePropertiesResponse = ns2.GetMultipleResourcePropertiesResponse_Dec().pyclass

