################################################## 
# Counter_services.py 
# generated by ZSI.generate.wsdl2python
##################################################


from pyGridWare.generated.types.performancecounter import *
import urlparse, types
import ZSI
from ZSI.TC import _get_global_element_declaration as GED
from ZSI.TCcompound import Struct
from pyGridWare.utility import client
from pyGridWare.utility.dom import DomletteReader, DomletteElementProxy
from twisted.python.failure import Failure

# Locator
class CounterServiceLocator:
    CounterPortType_address = "http://localhost:8080/wsrf/services/"
    def getCounterPortTypeAddress(self):
        return CounterServiceLocator.CounterPortType_address
    def getCounterPortType(self, url=None, **kw):
        return CounterPortTypeSOAPBindingSOAP(url or CounterServiceLocator.CounterPortType_address, **kw)

# Methods
class CounterPortTypeSOAPBindingSOAP:
    defer = False
    def __init__(self, url, endPointReference=None, **kw):
        kw.setdefault("readerclass", DomletteReader)
        kw.setdefault("writerclass", DomletteElementProxy)
        kw.setdefault("ResourceProperties", ("http://perf.counter.com","CounterRP"))
        self.binding = client.Binding(url=url, **kw)
        self.endPointReference = endPointReference

    # op: createCounter
    def createCounter(self, request):
        if isinstance(request, CreateCounterRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://perf.counter.com/CounterPortType/createCounterRequest"
        d = self.binding.Send(None, None, request, soapaction="http://perf.counter.com/CounterPortType/createCounterRequest", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://perf.counter.com/CounterPortType/createCounterResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=CreateCounterResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(CreateCounterResponse.typecode, wsaction=wsaction)
        if isinstance(response, CreateCounterResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: add
    def add(self, request):
        if isinstance(request, AddInputMessage) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://perf.counter.com/CounterPortType/addRequest"
        d = self.binding.Send(None, None, request, soapaction="http://perf.counter.com/CounterPortType/addRequest", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://perf.counter.com/CounterPortType/addResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=AddOutputMessage.typecode, address=d.address,
                wsaction=wsaction)
            d.addCallback(lambda response: AddOutputMessage(response))
            return d
        response = self.binding.Receive(AddOutputMessage.typecode, wsaction=wsaction)
        return AddOutputMessage(response)

    # op: Destroy
    def Destroy(self, request):
        if isinstance(request, DestroyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/DestroyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=DestroyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(DestroyResponse.typecode, wsaction=wsaction)
        if isinstance(response, DestroyResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: SetResourceProperties
    def SetResourceProperties(self, request):
        if isinstance(request, SetResourcePropertiesRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/SetResourceProperties"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/SetResourceProperties", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/SetResourcePropertiesResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=SetResourcePropertiesResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(SetResourcePropertiesResponse.typecode, wsaction=wsaction)
        if isinstance(response, SetResourcePropertiesResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: GetResourceProperty
    def GetResourceProperty(self, request):
        if isinstance(request, GetResourcePropertyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetResourcePropertyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetResourcePropertyResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetResourcePropertyResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: Subscribe
    def Subscribe(self, request):
        if isinstance(request, SubscribeRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/SubscribeResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=SubscribeResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(SubscribeResponse.typecode, wsaction=wsaction)
        if isinstance(response, SubscribeResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: GetCurrentMessage
    def GetCurrentMessage(self, request):
        if isinstance(request, GetCurrentMessageRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessageResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetCurrentMessageResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetCurrentMessageResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetCurrentMessageResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response
CreateCounterRequest = ns0.createCounter_Dec().pyclass

CreateCounterResponse = ns0.createCounterResponse_Dec().pyclass

class AddInputMessage(int):
    typecode = ns0.add_Dec()

class AddOutputMessage(int):
    typecode = ns0.addResponse_Dec()

DestroyRequest = ns1.Destroy_Dec().pyclass

DestroyResponse = ns1.DestroyResponse_Dec().pyclass

SetResourcePropertiesRequest = ns2.SetResourceProperties_Dec().pyclass

SetResourcePropertiesResponse = ns2.SetResourcePropertiesResponse_Dec().pyclass

class GetResourcePropertyRequest(tuple):
    typecode = ns2.GetResourceProperty_Dec()

GetResourcePropertyResponse = ns2.GetResourcePropertyResponse_Dec().pyclass

SubscribeRequest = ns3.Subscribe_Dec().pyclass

SubscribeResponse = ns3.SubscribeResponse_Dec().pyclass

GetCurrentMessageRequest = ns3.GetCurrentMessage_Dec().pyclass

GetCurrentMessageResponse = ns3.GetCurrentMessageResponse_Dec().pyclass

