################################################## 
# SecureConversation_services.py 
# generated by ZSI.generate.wsdl2python
##################################################


from pyGridWare.generated.types.secureconversation import *
import urlparse, types
import ZSI
from ZSI.TC import _get_global_element_declaration as GED
from ZSI.TCcompound import Struct
from pyGridWare.utility import client
from pyGridWare.utility.dom import DomletteReader, DomletteElementProxy
from twisted.python.failure import Failure

# Locator
class SecureConversationServiceLocator:
    SecureConversation_address = "http://localhost:8080/wsrf/services/"
    def getSecureConversationAddress(self):
        return SecureConversationServiceLocator.SecureConversation_address
    def getSecureConversation(self, url=None, **kw):
        return SecureConversationSOAPBindingSOAP(url or SecureConversationServiceLocator.SecureConversation_address, **kw)

# Methods
class SecureConversationSOAPBindingSOAP:
    defer = False
    def __init__(self, url, endPointReference=None, **kw):
        kw.setdefault("readerclass", DomletteReader)
        kw.setdefault("writerclass", DomletteElementProxy)
        # no resource properties
        self.binding = client.Binding(url=url, **kw)
        self.endPointReference = endPointReference

    # op: RequestSecurityToken
    def RequestSecurityToken(self, request):
        if isinstance(request, RequestSecurityTokenMsg) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://wsrf.globus.org/core/2004/07/security/secconv/SecureConversation/RequestSecurityTokenRequest"
        d = self.binding.Send(None, None, request, soapaction="http://wsrf.globus.org/core/2004/07/security/secconv/SecureConversation/RequestSecurityTokenRequest", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://wsrf.globus.org/core/2004/07/security/secconv/SecureConversation/RequestSecurityTokenResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=RequestSecurityTokenResponseMsg.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(RequestSecurityTokenResponseMsg.typecode, wsaction=wsaction)
        if isinstance(response, RequestSecurityTokenResponseMsg.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: RequestSecurityTokenResponse
    def RequestSecurityTokenResponse(self, request):
        if isinstance(request, RequestSecurityTokenResponseMsg) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://wsrf.globus.org/core/2004/07/security/secconv/SecureConversation/RequestSecurityTokenResponseRequest"
        d = self.binding.Send(None, None, request, soapaction="http://wsrf.globus.org/core/2004/07/security/secconv/SecureConversation/RequestSecurityTokenResponseRequest", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://wsrf.globus.org/core/2004/07/security/secconv/SecureConversation/RequestSecurityTokenResponseResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=RequestSecurityTokenResponseMsg.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(RequestSecurityTokenResponseMsg.typecode, wsaction=wsaction)
        if isinstance(response, RequestSecurityTokenResponseMsg.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response
RequestSecurityTokenMsg = ns21.RequestSecurityToken_Dec().pyclass

RequestSecurityTokenResponseMsg = ns21.RequestSecurityTokenResponse_Dec().pyclass

RequestSecurityTokenResponseMsg = ns21.RequestSecurityTokenResponse_Dec().pyclass

RequestSecurityTokenResponseMsg = ns21.RequestSecurityTokenResponse_Dec().pyclass

