############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

import ZSI.TC

from ZSI.TC import _get_global_element_declaration as GED
import pyGridWare.generated.types.managedjobservice

from pyGridWare.properties.ResourceProperties import ResourceProperties
from pyGridWare.properties.ResourceProperties import ScheduledResourceTerminationRP as _ScheduledResourceTerminationRP
from pyGridWare.properties.ResourceProperties import NotificationProducerRP as _NotificationProducerRP
class ManagedJobPortType(_ScheduledResourceTerminationRP,_NotificationProducerRP,ResourceProperties):
    declaration = GED("http://www.globus.org/namespaces/2004/10/gram/job","managedJobResourceProperties")

    def __init__(self):
        ResourceProperties.__init__(self)
        _ScheduledResourceTerminationRP.__init__(self)
        _NotificationProducerRP.__init__(self)

    def getserviceLevelAgreement(self):
        return self.getResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/description","serviceLevelAgreement")
    def setserviceLevelAgreement(self, pyobj):
        return self.setResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/description","serviceLevelAgreement", pyobj)
    serviceLevelAgreement = property(getserviceLevelAgreement, setserviceLevelAgreement, None, "RP element serviceLevelAgreement")

    def getstate(self):
        return self.getResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/types","state")
    def setstate(self, pyobj):
        return self.setResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/types","state", pyobj)
    state = property(getstate, setstate, None, "RP element state")

    def getfault(self):
        return self.getResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/faults","fault")
    def setfault(self, pyobj):
        return self.setResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/faults","fault", pyobj)
    fault = property(getfault, setfault, None, "RP element fault")

    def getlocalUserId(self):
        return self.getResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/types","localUserId")
    def setlocalUserId(self, pyobj):
        return self.setResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/types","localUserId", pyobj)
    localUserId = property(getlocalUserId, setlocalUserId, None, "RP element localUserId")

    def getuserSubject(self):
        return self.getResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/types","userSubject")
    def setuserSubject(self, pyobj):
        return self.setResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/types","userSubject", pyobj)
    userSubject = property(getuserSubject, setuserSubject, None, "RP element userSubject")

    def getholding(self):
        return self.getResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/types","holding")
    def setholding(self, pyobj):
        return self.setResourceProperty("http://www.globus.org/namespaces/2004/10/gram/job/types","holding", pyobj)
    holding = property(getholding, setholding, None, "RP element holding")

    def getTopic(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","Topic")
    def setTopic(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","Topic", pyobj)
    Topic = property(getTopic, setTopic, None, "RP element Topic")

    def getTopicExpressionDialects(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","TopicExpressionDialects")
    def setTopicExpressionDialects(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","TopicExpressionDialects", pyobj)
    TopicExpressionDialects = property(getTopicExpressionDialects, setTopicExpressionDialects, None, "RP element TopicExpressionDialects")

    def getTerminationTime(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","TerminationTime")
    def setTerminationTime(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","TerminationTime", pyobj)
    TerminationTime = property(getTerminationTime, setTerminationTime, None, "RP element TerminationTime")

    def getCapacity(self):
        return self.getResourceProperty("http://www.globus.org/namespaces/2004/09/rendezvous","Capacity")
    def setCapacity(self, pyobj):
        return self.setResourceProperty("http://www.globus.org/namespaces/2004/09/rendezvous","Capacity", pyobj)
    Capacity = property(getCapacity, setCapacity, None, "RP element Capacity")

    def getCurrentTime(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","CurrentTime")
    def setCurrentTime(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","CurrentTime", pyobj)
    CurrentTime = property(getCurrentTime, setCurrentTime, None, "RP element CurrentTime")

    def getRegistrantData(self):
        return self.getResourceProperty("http://www.globus.org/namespaces/2004/09/rendezvous","RegistrantData")
    def setRegistrantData(self, pyobj):
        return self.setResourceProperty("http://www.globus.org/namespaces/2004/09/rendezvous","RegistrantData", pyobj)
    RegistrantData = property(getRegistrantData, setRegistrantData, None, "RP element RegistrantData")

    def getRendezvousCompleted(self):
        return self.getResourceProperty("http://www.globus.org/namespaces/2004/09/rendezvous","RendezvousCompleted")
    def setRendezvousCompleted(self, pyobj):
        return self.setResourceProperty("http://www.globus.org/namespaces/2004/09/rendezvous","RendezvousCompleted", pyobj)
    RendezvousCompleted = property(getRendezvousCompleted, setRendezvousCompleted, None, "RP element RendezvousCompleted")

    def getFixedTopicSet(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","FixedTopicSet")
    def setFixedTopicSet(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","FixedTopicSet", pyobj)
    FixedTopicSet = property(getFixedTopicSet, setFixedTopicSet, None, "RP element FixedTopicSet")
