############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

import ZSI.TC

from ZSI.TC import _get_global_element_declaration as GED
import pyGridWare.generated.types.submanagerservice

from pyGridWare.properties.ResourceProperties import ResourceProperties
from pyGridWare.properties.ResourceProperties import SubscriptionManagerRP as _SubscriptionManagerRP
from pyGridWare.properties.ResourceProperties import ScheduledResourceTerminationRP as _ScheduledResourceTerminationRP
class SubscriptionManager(_SubscriptionManagerRP,_ScheduledResourceTerminationRP,ResourceProperties):
    declaration = GED("http://wsrf.globus.org/core/notification","SubscriptionManagerGTWSDLResourceProperties")

    def __init__(self):
        ResourceProperties.__init__(self)
        _SubscriptionManagerRP.__init__(self)
        _ScheduledResourceTerminationRP.__init__(self)

    def getConsumerReference(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","ConsumerReference")
    def setConsumerReference(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","ConsumerReference", pyobj)
    ConsumerReference = property(getConsumerReference, setConsumerReference, None, "RP element ConsumerReference")

    def getSelector(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","Selector")
    def setSelector(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","Selector", pyobj)
    Selector = property(getSelector, setSelector, None, "RP element Selector")

    def getUseNotify(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","UseNotify")
    def setUseNotify(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","UseNotify", pyobj)
    UseNotify = property(getUseNotify, setUseNotify, None, "RP element UseNotify")

    def getTopicExpression(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","TopicExpression")
    def setTopicExpression(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","TopicExpression", pyobj)
    TopicExpression = property(getTopicExpression, setTopicExpression, None, "RP element TopicExpression")

    def getSubscriptionPolicy(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","SubscriptionPolicy")
    def setSubscriptionPolicy(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","SubscriptionPolicy", pyobj)
    SubscriptionPolicy = property(getSubscriptionPolicy, setSubscriptionPolicy, None, "RP element SubscriptionPolicy")

    def getTerminationTime(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","TerminationTime")
    def setTerminationTime(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","TerminationTime", pyobj)
    TerminationTime = property(getTerminationTime, setTerminationTime, None, "RP element TerminationTime")

    def getCreationTime(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","CreationTime")
    def setCreationTime(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","CreationTime", pyobj)
    CreationTime = property(getCreationTime, setCreationTime, None, "RP element CreationTime")

    def getPrecondition(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","Precondition")
    def setPrecondition(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","Precondition", pyobj)
    Precondition = property(getPrecondition, setPrecondition, None, "RP element Precondition")

    def getCurrentTime(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","CurrentTime")
    def setCurrentTime(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","CurrentTime", pyobj)
    CurrentTime = property(getCurrentTime, setCurrentTime, None, "RP element CurrentTime")
