import ZSI
from pyGridWare.patterns import Singleton
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceContext import ResourceContext
from pyGridWare.generated.properties.basenotification.WS_BaseNotificationService.NotificationProducerPort import NotificationProducer
from pyGridWare.resource.ResourceContext import SubscriptionManagerContext as _SubscriptionManagerContext
from pyGridWare.generated.properties.basenotification.WS_BaseNotificationService.SubscriptionManagerPort import SubscriptionManager


class Key(int):
    typecode = ZSI.TC.Iint(pname=('http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.wsdl/service','WS-BaseNotificationKey'))


class ManagerHome(PersistentResourceHome, Singleton):
    def getResourceContext(self, ps, address):
        key = AddressingUtils.getResourceID(ps, Key.typecode)
        return self.get(key)


class NotificationProducerContext(ResourceContext):
    def __init__(self, properties_class=NotificationProducer):
        ResourceContext.__init__(self, properties_class)

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, Key(resourceID))
NotificationProducerContext.home = ManagerHome.getInstance()


class SubscriptionManagerContext(_SubscriptionManagerContext, ResourceContext):
    def __init__(self, properties_class=SubscriptionManager):
        ResourceContext.__init__(self, properties_class)
        _SubscriptionManagerContext.__init__(self, properties_class)

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, Key(resourceID))
SubscriptionManagerContext.home = ManagerHome.getInstance()

