import ZSI
from pyGridWare.patterns import Singleton
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceContext import ResourceContext
from pyGridWare.resource.ResourceContext import ScheduledResourceTerminationContext as _ScheduledResourceTerminationContext
from pyGridWare.generated.properties.counterservice.CounterService.CounterPortTypePort import CounterPortType


class Key(int):
    typecode = ZSI.TC.Iint(pname=('http://counter.com/service','CounterKey'))


class ManagerHome(PersistentResourceHome, Singleton):
    def getResourceContext(self, ps, address):
        key = AddressingUtils.getResourceID(ps, Key.typecode)
        return self.get(key)


class CounterPortTypeContext(_ScheduledResourceTerminationContext, ResourceContext):
    def __init__(self, properties_class=CounterPortType):
        ResourceContext.__init__(self, properties_class)
        _ScheduledResourceTerminationContext.__init__(self, properties_class)

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, Key(resourceID))
CounterPortTypeContext.home = ManagerHome.getInstance()

