import ZSI
from pyGridWare.patterns import Singleton
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceContext import ResourceContext
from pyGridWare.generated.properties.delegationservice.DelegationFactoryService.DelegationFactoryPortTypePort import DelegationFactoryPortType


class Key(int):
    typecode = ZSI.TC.Iint(pname=('http://www.globus.org/08/2004/delegationService/service','DelegationFactoryServiceKey'))


class ManagerHome(PersistentResourceHome, Singleton):
    def getResourceContext(self, ps, address):
        key = AddressingUtils.getResourceID(ps, Key.typecode)
        return self.get(key)


class DelegationFactoryPortTypeContext(ResourceContext):
    def __init__(self, properties_class=DelegationFactoryPortType):
        ResourceContext.__init__(self, properties_class)

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, Key(resourceID))
DelegationFactoryPortTypeContext.home = ManagerHome.getInstance()

