import ZSI
from pyGridWare.patterns import Singleton
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceContext import ResourceContext
from pyGridWare.generated.properties.gramfactoryservice.ManagedJobFactoryService.ManagedJobFactoryPortTypePort import ManagedJobFactoryPortType


class Key(int):
    typecode = ZSI.TC.Iint(pname=('http://www.globus.org/namespaces/2004/10/gram/job/service','ManagedJobFactoryKey'))


class ManagerHome(PersistentResourceHome, Singleton):
    def getResourceContext(self, ps, address):
        key = AddressingUtils.getResourceID(ps, Key.typecode)
        return self.get(key)


class ManagedJobFactoryPortTypeContext(ResourceContext):
    def __init__(self, properties_class=ManagedJobFactoryPortType):
        ResourceContext.__init__(self, properties_class)

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, Key(resourceID))
ManagedJobFactoryPortTypeContext.home = ManagerHome.getInstance()

