import ZSI
from pyGridWare.patterns import Singleton
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceContext import ResourceContext
from pyGridWare.resource.ResourceContext import SubscriptionManagerContext as _SubscriptionManagerContext
from pyGridWare.generated.properties.submanagerservice.SubscriptionManagerService.SubscriptionManagerPort import SubscriptionManager


class Key(int):
    typecode = ZSI.TC.Iint(pname=('http://wsrf.globus.org/core/notification/service','SubscriptionManagerServiceKey'))


class ManagerHome(PersistentResourceHome, Singleton):
    def getResourceContext(self, ps, address):
        key = AddressingUtils.getResourceID(ps, Key.typecode)
        return self.get(key)


class SubscriptionManagerContext(_SubscriptionManagerContext, ResourceContext):
    def __init__(self, properties_class=SubscriptionManager):
        ResourceContext.__init__(self, properties_class)
        _SubscriptionManagerContext.__init__(self, properties_class)

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, Key(resourceID))
SubscriptionManagerContext.home = ManagerHome.getInstance()

