############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

from pyGridWare.generated.services.stubs.delegationservice.DelegationFactoryService import *
from pyGridWare.generated.resource.delegationservice.DelegationFactoryService import ManagerHome
from pyGridWare.generated.resource.delegationservice.DelegationFactoryService import DelegationFactoryPortTypeContext


class DelegationFactoryServiceWSRF(DelegationFactoryService):

    def GetResourceContext(ps, address):
        """get a resource context"""
        return ManagerHome.getInstance().getResourceContext(ps, address)
    GetResourceContext = staticmethod(GetResourceContext)

    def NewResourceContextDelegationFactoryPortTypePort(cls, url):
        """create a new resource context"""
        ctx = DelegationFactoryPortTypeContext()
        ctx.setAddress(url)
        home = ctx.getResourceHome()
        key = home.create()
        home.add(ctx, key)
        ctx.setResourceID(key)
        return ctx
    NewResourceContextDelegationFactoryPortTypePort = classmethod(NewResourceContextDelegationFactoryPortTypePort)

    def wsa_RequestSecurityToken(self, ps, address, **kw):
        #http://schemas.xmlsoap.org/ws/2004/04/trust RequestSecurityTokenMsg
        response = DelegationFactoryService.wsa_RequestSecurityToken(self, ps, address)
        return response

    def wsa_RequestSecurityToken2(self, ps, address, **kw):
        #http://schemas.xmlsoap.org/ws/2004/04/trust RequestSecurityTokenMsg
        response = DelegationFactoryService.wsa_RequestSecurityToken2(self, ps, address)
        return response

    def wsa_QueryResourceProperties(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl QueryResourcePropertiesRequest
        response = DelegationFactoryService.wsa_QueryResourceProperties(self, ps, address)
        ctx = ManagerHome.getInstance().getResourceContext(ps, address)
        response._any = ctx.properties.query(self.request._QueryExpression, response)
        return response

    def wsa_GetResourceProperty(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl GetResourcePropertyRequest
        response = DelegationFactoryService.wsa_GetResourceProperty(self, ps, address)
        ctx = ManagerHome.getInstance().getResourceContext(ps, address)
        namespaceURI,element = self.request
        property = ctx.properties.getResourceProperty(namespaceURI,element)
        response._any = [property]
        return response

