############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

from pyGridWare.generated.resource.managedjobfactory.ManagedJobFactoryService import ManagerHome
from pyGridWare.generated.resource.managedjobfactory.ManagedJobFactoryService import ManagedJobFactoryPortTypeContext
from pyGridWare.generated.services.stubs.managedjobfactory.ManagedJobFactoryService import *


class ManagedJobFactoryServiceWSRF(ManagedJobFactoryService):

    def GetResourceContext(ps, address):
        """get a resource context"""
        return ManagerHome.getInstance().getResourceContext(ps, address)
    GetResourceContext = staticmethod(GetResourceContext)

    def NewResourceContextManagedJobFactoryPortTypePort(cls, url):
        """create a new resource context"""
        ctx = ManagedJobFactoryPortTypeContext()
        ctx.setAddress(url)
        home = ctx.getResourceHome()
        key = home.create()
        home.add(ctx, key)
        ctx.setResourceID(key)
        return ctx
    NewResourceContextManagedJobFactoryPortTypePort = classmethod(NewResourceContextManagedJobFactoryPortTypePort)

    def wsa_createManagedJob(self, ps, address, **kw):
        #http://www.globus.org/namespaces/2004/10/gram/job createManagedJobInputMessage
        response = ManagedJobFactoryService.wsa_createManagedJob(self, ps, address)
        return response

    def wsa_QueryResourceProperties(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl QueryResourcePropertiesRequest
        response = ManagedJobFactoryService.wsa_QueryResourceProperties(self, ps, address)
        ctx = ManagerHome.getInstance().getResourceContext(ps, address)
        response._any = ctx.properties.query(self.request._QueryExpression, response)
        return response

    def wsa_GetMultipleResourceProperties(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl GetMultipleResourcePropertiesRequest
        response = ManagedJobFactoryService.wsa_GetMultipleResourceProperties(self, ps, address)
        ctx = ManagerHome.getInstance().getResourceContext(ps, address)
        response._any = []
        for nsuri,name in self.request._ResourceProperty:
            response._any.append(ctx.properties.getResourceProperty(nsuri, name))
        return response

    def wsa_GetResourceProperty(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl GetResourcePropertyRequest
        response = ManagedJobFactoryService.wsa_GetResourceProperty(self, ps, address)
        ctx = ManagerHome.getInstance().getResourceContext(ps, address)
        namespaceURI,element = self.request
        property = ctx.properties.getResourceProperty(namespaceURI,element)
        response._any = [property]
        return response

