############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

from pyGridWare.generated.services.stubs.resourceproperties.WS_ResourcePropertiesService import *


class WS_ResourcePropertiesServiceWSRF(WS_ResourcePropertiesService):

    def GetResourceContext(ps, address):
        """get a resource context"""
        return ManagerHome.getInstance().getResourceContext(ps, address)
    GetResourceContext = staticmethod(GetResourceContext)

    def wsa_QueryResourceProperties(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl QueryResourcePropertiesRequest
        response = WS_ResourcePropertiesService.wsa_QueryResourceProperties(self, ps, address)
        ctx = ManagerHome.getInstance().getResourceContext(ps, address)
        response._any = ctx.properties.query(self.request._QueryExpression, response)
        return response

    def wsa_GetMultipleResourceProperties(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl GetMultipleResourcePropertiesRequest
        response = WS_ResourcePropertiesService.wsa_GetMultipleResourceProperties(self, ps, address)
        ctx = ManagerHome.getInstance().getResourceContext(ps, address)
        response._any = []
        for nsuri,name in self.request._ResourceProperty:
            response._any.append(ctx.properties.getResourceProperty(nsuri, name))
        return response

    def wsa_SetResourceProperties(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl SetResourcePropertiesRequest
        response = WS_ResourcePropertiesService.wsa_SetResourceProperties(self, ps, address)
        ctx = ManagerHome.getInstance().getResourceContext(ps, address)
        if self.request._Insert is not None:
            raise NotImplemetedError, "SetResourceProperties insert not implemented"
        elif self.request._Update is not None:
            for any in self.request._Update._any:
                nspname,pname = any.typecode.nspname,any.typecode.pname
                ctx.properties.setResourceProperty(nspname, pname, any)
        elif self.request._Delete is not None:
            raise NotImplemetedError, "SetResourceProperties delete not implemented"
        else:
            raise RuntimeError, "unknown request for SetResourceProperties."
        return response

    def wsa_GetResourceProperty(self, ps, address, **kw):
        #http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.wsdl GetResourcePropertyRequest
        response = WS_ResourcePropertiesService.wsa_GetResourceProperty(self, ps, address)
        ctx = ManagerHome.getInstance().getResourceContext(ps, address)
        namespaceURI,element = self.request
        property = ctx.properties.getResourceProperty(namespaceURI,element)
        response._any = [property]
        return response

