################################################## 
# ManagedJobFactory_services.py 
# generated by ZSI.generate.wsdl2python
##################################################


from pyGridWare.generated.types.gramfactoryservice import *
import urlparse, types
import ZSI
from ZSI.TC import _get_global_element_declaration as GED
from ZSI.TCcompound import Struct
from pyGridWare.utility import client
from pyGridWare.utility.dom import DomletteReader, DomletteElementProxy
from twisted.python.failure import Failure

# Locator
class ManagedJobFactoryServiceLocator:
    ManagedJobFactoryPortType_address = "http://localhost:8080/wsrf/services/"
    def getManagedJobFactoryPortTypeAddress(self):
        return ManagedJobFactoryServiceLocator.ManagedJobFactoryPortType_address
    def getManagedJobFactoryPortType(self, url=None, **kw):
        return ManagedJobFactoryPortTypeSOAPBindingSOAP(url or ManagedJobFactoryServiceLocator.ManagedJobFactoryPortType_address, **kw)

# Methods
class ManagedJobFactoryPortTypeSOAPBindingSOAP:
    defer = False
    def __init__(self, url, endPointReference=None, **kw):
        kw.setdefault("readerclass", DomletteReader)
        kw.setdefault("writerclass", DomletteElementProxy)
        kw.setdefault("ResourceProperties", ("http://www.globus.org/namespaces/2004/10/gram/job","managedJobFactoryResourceProperties"))
        self.binding = client.Binding(url=url, **kw)
        self.endPointReference = endPointReference

    # op: createManagedJob
    def createManagedJob(self, request):
        if isinstance(request, createManagedJobInputMessage) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobFactoryPortType/createManagedJobRequest"
        d = self.binding.Send(None, None, request, soapaction="http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobFactoryPortType/createManagedJobRequest", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://www.globus.org/namespaces/2004/10/gram/job/ManagedJobFactoryPortType/createManagedJobResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=createManagedJobOuputMessage.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(createManagedJobOuputMessage.typecode, wsaction=wsaction)
        if isinstance(response, createManagedJobOuputMessage.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: QueryResourceProperties
    def QueryResourceProperties(self, request):
        if isinstance(request, QueryResourcePropertiesRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourceProperties"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourceProperties", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourcePropertiesResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=QueryResourcePropertiesResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(QueryResourcePropertiesResponse.typecode, wsaction=wsaction)
        if isinstance(response, QueryResourcePropertiesResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: GetMultipleResourceProperties
    def GetMultipleResourceProperties(self, request):
        if isinstance(request, GetMultipleResourcePropertiesRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourceProperties"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourceProperties", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourcePropertiesResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetMultipleResourcePropertiesResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetMultipleResourcePropertiesResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetMultipleResourcePropertiesResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    # op: GetResourceProperty
    def GetResourceProperty(self, request):
        if isinstance(request, GetResourcePropertyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetResourcePropertyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetResourcePropertyResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetResourcePropertyResponse.typecode.pyclass) is False:
            if self.binding.failure is not None: self.binding.failure.raiseException()
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response
createManagedJobInputMessage = ns11.createManagedJob_Dec().pyclass

createManagedJobOuputMessage = ns11.createManagedJobResponse_Dec().pyclass

QueryResourcePropertiesRequest = ns2.QueryResourceProperties_Dec().pyclass

QueryResourcePropertiesResponse = ns2.QueryResourcePropertiesResponse_Dec().pyclass

GetMultipleResourcePropertiesRequest = ns2.GetMultipleResourceProperties_Dec().pyclass

GetMultipleResourcePropertiesResponse = ns2.GetMultipleResourcePropertiesResponse_Dec().pyclass

class GetResourcePropertyRequest(tuple):
    typecode = ns2.GetResourceProperty_Dec()

GetResourcePropertyResponse = ns2.GetResourcePropertyResponse_Dec().pyclass

